# -*- coding: utf-8 -*-
#!/usr/bin/env python
import os
import sys
from PIL import Image
from PIL import ImageChops

path = "/Users/kopanitsa/monkeyrunner_util/monkeyrunner_script/"

def checkDiff(file):
	# read 2 files
	image1 = Image.open(path + 'before/' + file, "r")
	try:
		image2 = Image.open(path + 'after/' + file, "r")
	except IOError, (errno, msg):
		print 'except: Cannot open "%s"' % image2
		print '  errno: [%d] msg: [%s]' % (errno, msg)

	# create diff image
	size = image1.size
	diff = Image.new( 'RGBA', ( size[0], size[1] ) )

	# check diff
	diff = ImageChops.difference(image1, image2)
	diffdata = list(diff.getdata())
	total = 0
	for i in range(2):
		for d in diffdata:
			total += d[i]
	if total != 0:
		print('   ' + file + ' has difference! (' + str(total) + ')')
		f = open(path + 'diff/result.txt', 'a')
		f.write(file+'\n')
		f.close()
	else:
		print('   ' + file + ' has NO difference!')

	# save
	diff.save(path + 'diff/' + file, "png" )
	

# ------- main ------------------------------------

files = os.listdir(path+'before')
for file in files:
	print(file)
	checkDiff(file)

