# -*- coding: utf-8 -*-
#!/usr/bin/env python
import os
import sys
import string
import re

## --------------------- initialize --------------------------------------
argvs = sys.argv
argc = len(argvs)
print argvs
print argc
print
if (argc != 5):
  print 'invalid parameter number'
  quit()

# input file name. Logcat log file.
inputFileName = "logcat/"+argvs[1]
print "input file name :" + inputFileName
# header file. described import text for monkeyrunner.
headerFileName = "res/header.txt"
# header file. described activity initiation command etc.
header2FileName = "res/header2.txt"
# header file. described snapshot command etc
footerFileName = "res/footer.txt"

# file path for created monkey runner script
if os.path.exists("./out") == False:
  os.mkdir("out")
snapshotDirName = "snapshot"
testCaseId = argvs[2] # "StartApplication_01_1"
print "testCaseId :" + testCaseId
# created monkeyrunner script
outputFileName = "out/" + testCaseId + "_testscript.py"
# snapshot name taken by monkeyrunner
snapshotFileName = snapshotDirName + "/" + testCaseId + ".png"

# use for calcurate event duration.
constantTiming = argvs[3]
constantTime = "1.0"
time = 0

path = argvs[4]

# TODO
# This value for logcat counts twice for one touch event...
# This should be avoid on source code side...
previousTouchEvent = ''

## --------------------- methods --------------------------------------
# method to write file information to monkeyrinner script
def writeTestCaseParam(fw):
  s = 'dirName = \'' + snapshotDirName +'\'\r\n'
  fw.write(s)
  s = 'testcaseId = \'' + testCaseId +'\'\r\n'
  fw.write(s)
  s = 'fileName = \'' + path + snapshotFileName + '\'\r\n'
  fw.write(s)


# method to analyze log and create monkeyrunner command
def createTouchActionLine(event):
  if len(event) != 8:
    print "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
    print "!!!!  invalid parameter length:" + str(len(event))
    print "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
    return
    
  # TODO see value definition. can it be removed?
  global previousTouchEvent
  if event[1] == previousTouchEvent:
    return ''
  previousTouchEvent = event[1]

  # ----------------------------------
  #action = ''
  #if event[1] == "0":
  #  action += "'DOWN'"
  #elif event[1] == "1" or event[1] == "4" or event[1] == "3": #  1: UP, 3:CANCEL, 4:OUTSIDE
  #  action += "'UP'"
  #elif event[1] == "2": # 2:MOVE, if input event is "MOVE", ignore.
  #  return '' 
  #else:
  #  action = "!!!!  UNKNOWN :" + event[1]
  # ----------------------------------
  action = ''
  if event[1] == "0":
    action += "'DOWN_AND_UP'"
  elif event[1] == "1" or event[1] == "2" or event[1] == "3" or event[1] == "4":
    return '' 
  else:
    action = "!!!!  UNKNOWN :" + event[1]
  # ----------------------------------
  actionLine = 'device.touch(' + event[3] + ',' + event[5] +',' + action + ')\r\n'
  return actionLine


# method to analyze log and create monkeyrunner command
def createKeyActionLine(event):
  if len(event) != 6:
    print "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
    print "!!!!  invalid parameter length:" + str(len(event))
    print "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
    return
  
  action = ''
  # key type
  if event[1] == "80":
    action += "'KEYCODE_FOCUS'"
  elif event[1] == "27":
    action += "'KEYCODE_CAMERA'"
  elif event[1] == "4":
    action += "'KEYCODE_BACK'"
  elif event[1] == "3":
    action += "'KEYCODE_HOME'"
  elif event[1] == "82":
    action += "'KEYCODE_MENU'"
  elif event[1] == "26":
    action += "'KEYCODE_POWER'"
  else:
    action += "!!!!  UNKNOWN : " + event[1]
  action += ","
  # key event type
  if event[3] == "0":
    action += "'DOWN'"
  elif event[3] == "1":
    action += "'UP'"
  actionLine = 'device.press(' + action + ')\r\n'
  return actionLine
  

# method to calcurate inter-event duration for touch event.
def createSleepLineOnTouch(event):
  global time
  # if constant flag is true, sleep during "constantTime"
  if constantTiming == str(True):
    return "MonkeyRunner.sleep(" + constantTime + ')\r\n'
  # if event is ignored on createActionLine function(i.e. MOVE, FLICK), dont sleep
  if event[1] == "2":
    return ''
  if time == 0:
    time = event[7]
    return ''
  duration = (float(event[7]) - float(time)) / 1000.0 # msec -> sec
  time = event[7]
  sleepLine = "MonkeyRunner.sleep(" + str(duration) + ')\r\n'
  return sleepLine


# method to calcurate inter-event duration for key event.
def createSleepLineOnKey(event):
  global time
  # if constant flag is true, sleep during "constantTime"
  if constantTiming == str(True):
    return "MonkeyRunner.sleep(" + constantTime + ')\r\n'
  if time == 0:
    time = event[5]
    return ''
  duration = (float(event[5]) - float(time)) / 1000.0 # msec -> sec
  time = event[5]
  sleepLine = "MonkeyRunner.sleep(" + str(duration) + ')\r\n'
  return sleepLine


## --------------------- main --------------------------------------
# main function
# file open
try:
  frInput = open(inputFileName,"r")
  frHeader = open(headerFileName,"r")
  frHeader2 = open(header2FileName,"r")
  frFooter = open(footerFileName,"r")
  fw = open(outputFileName,"w")
except:
    print "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
    print "!!!! cannot open input.txt"
    print "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"

# write header information to output file(monkey script)
for line in frHeader:
  fw.write(line)
writeTestCaseParam(fw)
for line in frHeader2:
  fw.write(line)

# analyze log and write monkeyrunner command to output file
for line in frInput:
  # touch event
  if re.search("MonkeyRunnerTouchLog",line) != None:
	tmp = re.sub("^.*MonkeyRunnerTouchLog@","",line)
	tmp = re.sub("\r\n","",tmp)
	event = re.split('@',tmp)
	sleepLine = createSleepLineOnTouch(event)
	actionLine = createTouchActionLine(event)
	print sleepLine
	print actionLine
	fw.write(sleepLine)
	fw.write(actionLine)
  # key event
  elif re.search("MonkeyRunnerKeyLog",line) != None:
	tmp = re.sub("^.*MonkeyRunnerKeyLog@","",line)
	tmp = re.sub("\r\n","",tmp)
	event = re.split('@',tmp)
	sleepLine = createSleepLineOnKey(event)
	actionLine = createKeyActionLine(event)
	print sleepLine
	print actionLine
	fw.write(sleepLine)
	fw.write(actionLine)

# write footer
for line in frFooter:
  fw.write(line)

# close file
fw.close()


